<?php

class Text_Base
{
	var	$headers;

	var $base;
	var $base_filename;

	var $head;
	var $head_filename;

	var $rows;
	var	$columns;
	var $raz;
	var $reverse;
	var $_sort_i;

	function Text_Base($file, $head=true, $head_filename='', $raz=RAZ)
	{
		$this->raz=$raz;
		$this->headers=array();
		$this->base_filename=$file;
		$this->head=$head;
		$this->head_filename=$head_filename;

		if ($head and empty($head_filename))	$this->head_filename=$file.'.head';

		$this->reverse=false;

		$this->base=print_afile($file);
		if (!count($this->base))
		{
			$this->columns=0;
			$this->rows=0;
		}
		else
		{
			$this->columns=count($this->headers);
			$this->rows=count($this->base);
		}

		if ($head)
		{
			$this->headers=explode($this->raz, rtrim(print_file($this->head_filename)));
		}
		else
		{
			$this->headers=explode($this->raz, rtrim($this->base[0]));
			$this->base=array_shift($this->base);
		}
	}

	function SetHeaders($text)
	{
		$this->headers=explode($this->raz, trim($text));
		$this->head=true;
	}

	function Reverse()
	{
		if ($this->rows)
		{
			if ($this->reverse)	$this->reverse=false;
			else	$this->reverse=true;

			$this->base=array_reverse($this->base);
		}
	}

	function DeleteRow($col, $id)
	{
		if (empty($col) or empty($id))	return false;
		$i=$this->SearchNRow($col, $id);
		if ($i!==false)
		{
			unset($this->base[$i]);
			$this->rows--;
			return true;
		}
		return false;
	}

	function DeleteNRow($row)
	{
		if (isset($this->base[$row]))
		{
			unset($this->base[$row]);
			$this->rows--;
		}

		return false;
	}

	function GetFirstRow()
	{
		if	($this->rows)	return $this->GetRow(0);

		return false;
	}

	function GetLastRow()
	{
		if	($this->rows)	return $this->GetRow($this->rows-1);

		return false;
	}

	function GetRow($n)
	{
		$array=array();
		$buf=explode($this->raz, rtrim($this->base[$n]));

		for($i=0; $i<count($buf); $i++)
		{
			$buf[$i]=$this->depackword($buf[$i]);
		}

		if (count($this->headers))
		{
			$i=0;
			foreach($this->headers as $str)
			{
				$array[$str]=$buf[$i];
				$i++;
			}
		}
		else
		{
			$array=$buf;
		}


		return $array;
	}

	function AddRow($array)
	{
		$rev_old=$this->reverse;
		if ($this->reverse)	$this->Reverse();
		if (count($this->headers))
		{
			$add='';
			foreach($this->headers as $buf)
			{
				$add.=$this->packword($array[$buf]);
				$add.=$this->raz;
			}
			$add.=$this->raz."\n";
			$this->base[]=$add;
		}
		else
		{
			for($i=0; $i<count($array); $i++)
			{
				$array[$i]=$this->packword($array[$i]);
			}

			$this->base[]=implode($this->raz, $array).$this->raz."\n";
		}
		$this->rows++;

		if ($rev_old)	$this->Reverse();
	}

	function packword($text)
	{
		$text=str_replace($this->raz, '[raz]', $text);
		$text=str_replace("\n", '[n]', $text);
		$text=str_replace("\r", '', $text);

		return $text;
	}

	function depackword($text)
	{
		$text=str_replace('[raz]', $this->raz, $text);
		$text=str_replace('[n]', "\n", $text);

		return $text;
	}

	function DownRow($col, $id, $n=1)
	{
		if ($i=$this->SearchRow($col, $id)!==false)
		{
			if (isset($this->base[$i+$n]))
			{
				$buf=$this->base[$i+$n];
				$this->base[$i+$n]=$this->base[$i];
				$this->base[$i]=$buf;

				return true;
			}
		}
		return false;
	}

	function Sort()
	{
		sort($this->base);
	}

	function UpRow($col, $id, $n=1)
	{
		if ($i=$this->SearchRow($col, $id)!==false)
		{
			if (isset($this->base[$i-$n]))
			{
				$buf=$this->base[$i-$n];
				$this->base[$i-$n]=$this->base[$i];
				$this->base[$i]=$buf;

				return true;
			}
		}

		return false;
	}

	function SearchRow($col, $id)
	{
		$res=$this->SearchNRow($col, $id);
		if ($res!==false)	return $this->GetRow($res);

		return false;
	}

	function SearchNRow($col, $id)
	{
		$n=0;
		if (count($this->headers))
		{
			$n=$this->SearchNHeader($col);
			if ($n===false)	return false;
		}

		$i=0;
		foreach($this->base as $buf)
		{
			$id=$this->packword($id);
			$buf2=explode($this->raz, $buf);
			if ($buf2[$n]==$id)	return $i;
			$i++;
		}

		return false;
	}

	function SearchNHeader($col)
	{
		$i=0;
		foreach($this->headers as $buf)
		{
			if ($buf==$col)	return $i;
			$i++;
		}

		return false;
	}

	function EditRow($col, $id, $array)
	{
		$n=$this->SearchNRow($col, $id);

		if ($n===false)	return false;

		if (count($this->headers))
		{
			$add='';
			foreach($this->headers as $buf)
			{
				$add.=$array[$buf];
				$add.=$this->raz;
			}
			$add.="\n";
			$this->base[$n]=$add;
		}
		else
		{
			$this->base[$n]=implode(RAZ, $array)."\n";
		}
	}

	function Save()
	{
		//if (!$this->head)	$buf=array_unshift(implode($this->raz, $this->headers));

		if (!$this->rows)
		{
			savew($this->base_filename, '');
		}
		else
		{
			if ($this->reverse)	$this->Reverse();
			$buf=implode('', $this->base);
			savew($this->base_filename, $buf);
		}
	}
	function Clear()
	{
		$this->base=array();
		$this->rows=0;
		$this->columns=0;
	}
}

?>
